
#    vme.common.tcl

if {[info exists CurrentVMEServer] == 0} then {

   if {[info exists env(VmeServer)] == 0} then {set CurrentVMEServer vme}  \
      else {set CurrentVMEServer $env(VmeServer)}
}

if {[info exists CurrentVMEModule] == 0} then {set CurrentVMEModule ""}
if {[info exists VMEregister] == 0} then {set VMEregister ""}

proc VMEmodule2server {m} {inform vmecontrol VMEmodule2server $m}

proc define-vme-register {mname class rname attributes} {
   global CurrentVMEServer VMEregister
   global EGallow
   set VMEregister /$CurrentVMEServer/$mname.$rname
#   insert-debug "define-vme-register $VMEregister $class $attributes"
#     until we fix the VxWorks regsiter server to made delete work fully
#     ignore an already exists return to create
   set egallow $EGallow
   set EGallow 0x20006
   EG "register :name '$VMEregister' :class '$class' !new"
   set EGallow $egallow
   EG "register :name '$VMEregister' :object '$attributes'"
}

proc delete-vme-registers {registers} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$registers
#   insert-debug "delete-vme-registers $VMEregister"
   EG "register :pattern '$VMEregister' !delete"
}

proc delete-vme-register {register} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG "register :name '$VMEregister' !delete"
}

proc write-vme-attribute {register vl} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG  "register :name '$VMEregister' :object '$vl'"
}

proc modify-vme-register {register vl} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG  "register :name '$VMEregister' :object '$vl'"
}

proc read-vme-attribute {register} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   return  [EG "register :name '$VMEregister' ?object"]
}

proc write-vme-attributes {register vl} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG  "register :pattern '$VMEregister' :object '$vl'"
}

proc modify-vme-registers {register vl} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG  "register :pattern '$VMEregister' :object '$vl'"
}

proc read-vme-attributes {register} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   return  [EG "register :pattern '$VMEregister' ?names-and-objects"]
}

proc initialise-vme-register {register} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$register
   EG  "register :name '$VMEregister' !initialise"
}

proc initialise-vme-registers {registers} {
   global CurrentVMEServer VMEregister
   set VMEregister /$CurrentVMEServer/$registers
   EG  "register :pattern '$VMEregister' !initialise"
}

proc read-vme-register {register} {
   global CurrentVMEServer VMEregister EGallow
   DA_pause 0
#   set EGallow 0x10002
   set VMEregister /$CurrentVMEServer/$register
   set vl [EG "register :name '$VMEregister' ?value"]
   DA_pause 1
   return $vl
}

proc read-vme-registers {register} {
   global CurrentVMEServer VMEregister EGallow
   DA_pause 0
   set EGallow 0x10004
   set VMEregister /$CurrentVMEServer/$register
   set vl [EG "register :pattern '$VMEregister' ?names-and-values"]
   DA_pause 1
   return $vl
}

proc write-vme-register {register value} {
   global CurrentVMEServer TrigServer TrigModule VMEregister EGallow
   DA_pause 0
   set EGallow 0xffffffff
   set VMEregister /$CurrentVMEServer/$register
   EG "register :name '$VMEregister' :value '$value'"
   DA_pause 1
}

proc write-vme-registers {register value} {
   global CurrentVMEServer VMEregister EGallow
   DA_pause 0
   set EGallow 0xffffffff
   set VMEregister /$CurrentVMEServer/$register
   EG "register :pattern '$VMEregister' :value '$value'"
   DA_pause 1
}

#    This is a dummy procedure which is intended to be overwritten if the action is required
proc DA_pause {opt} {}

proc ersdefine {register class} {
   global CurrentVMEServer
   EG "register :name '/$CurrentVMEServer/$register' :class '$class' !new"
}

proc ersinquire {register} {
   global CurrentVMEServer
   EG "register :pattern '/$CurrentVMEServer/$register' ?names"
}

proc erswta {register args} {
   global CurrentVMEServer
   EG "register  :name '/$CurrentVMEServer/$register' :object '$args'"
}

