#  V1290.defn.tcl

proc {Add_CAEN V1290_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME GEO_Address         "-a$A32addrbase -w32 -o0x100e -prw -d16 -l5 -b0 -zx -i$moduleID"
   define-vme-register $name xVME Intr_Level          "-a$A32addrbase -w32 -o0x100a -prw -d16 -l3 -b0 -zd -i$interruptlevel"
   define-vme-register $name xVME Intr_Vec            "-a$A32addrbase -w32 -o0x100c -prw -d16 -l8 -b0 -zd -i$interruptvector"

   define-vme-register $name xVME Status              "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Status.DRDY         "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b0 -zd"
   define-vme-register $name xVME Status.AMFull       "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b1 -zd"
   define-vme-register $name xVME Status.Full         "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b2 -zd"
   define-vme-register $name xVME Status.TrgMatch     "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b3 -zd"
   define-vme-register $name xVME Status.HdrEnabl     "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b4 -zd"
   define-vme-register $name xVME Status.Term         "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l1 -b5 -zd"
   define-vme-register $name xVME Status.Error        "-a$A32addrbase -w32 -o0x1002 -pro -d16 -l4 -b6 -zd"

   define-vme-register $name xVME Ctrl                "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Ctrl.BERR           "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME Ctrl.TERM           "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b1 -zd"
   define-vme-register $name xVME Ctrl.Term_Mode      "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b2 -zd"
   define-vme-register $name xVME Ctrl.Event_Mode     "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b3 -zd"
   define-vme-register $name xVME Ctrl.Align64        "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b4 -zd"
   define-vme-register $name xVME Ctrl.TestMode       "-a$A32addrbase -w32 -o0x1000 -prw -d16 -l1 -b5 -zd"

   define-vme-register $name xVME ADER_HIGH           "-a$A32addrbase -w32 -o0x1004 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ADER_LOW            "-a$A32addrbase -w32 -o0x1006 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ADER_ENABLE         "-a$A32addrbase -w32 -o0x1008 -pwo -d16 -l1 -b0 -zx"
   define-vme-register $name xVME MCST/CBLT_Address   "-a$A32addrbase -w32 -o0x1010 -prw -d16 -l8 -b0 -zx -i0xAA"
   define-vme-register $name xVME MCST/CBLT_Ctrl      "-a$A32addrbase -w32 -o0x1012 -pwo -d16 -l2 -b0 -zx"

   define-vme-register $name xVME EvCounter           "-a$A32addrbase -w32 -o0x101e -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME EvStored            "-a$A32addrbase -w32 -o0x1020 -pro -d16 -l0 -b0 -zx"

   define-vme-register $name xVME HWM                 "-a$A32addrbase -w32 -o0x1022 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME TestReg             "-a$A32addrbase -w32 -o0x1028 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OUT_PROG            "-a$A32addrbase -w32 -o0x102c -prw -d16 -l0 -b0 -zx"

   define-vme-register $name xVME OpCodeCtrl          "-a$A32addrbase -w32 -o0x1030 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OpCode              "-a$A32addrbase -w32 -o0x102e -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OpCode_Cmd          "-a$A32addrbase -w32 -o0x102e -prw -d16 -l8 -b8 -zx"
   define-vme-register $name xVME OpCode_Obj          "-a$A32addrbase -w32 -o0x102e -prw -d16 -l8 -b0 -zx"

   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x1018 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Reset               "-a$A32addrbase -w32 -o0x1014 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME SoftTrig            "-a$A32addrbase -w32 -o0x101c -pwo -d16 -l0 -b0 -zx"

   define-vme-register $name xVME Test16              "-a$A32addrbase -w32 -o0x1204 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Test32              "-a$A32addrbase -w32 -o0x1200 -prw -d32 -l0 -b0 -zx"

   define-vme-register $name xVME Firmware            "-a$A32addrbase -w32 -o0x1026 -pro -d16 -l8 -b0 -zx"

   define-vme-register $name bVME Output_Buffer       "-a$A32addrbase -w32 -o0x0 -pro -d32 -zx -l64"
   define-vme-register $name xVME Output_Word         "-a$A32addrbase -w32 -o0x0 -pro -d32 -l0 -b0 -zx"

}

proc {CAEN V1290_registers} {} {
    global registers_table

    set registers_table   {                                              \
        {"GEO Address Register"                GEO_Address}              \
        {"Interrupt Level Register"            Intr_Level}               \
        {"Interrupt Vector Register"           Intr_Vec}                 \
        {"Status Register"                     Status}                  \
        {"Control Register"                    Ctrl}                    \
        {"Address Decoder High Register"       ADER_HIGH}                \
        {"Address Decoder Low Register"        ADER_LOW}                 \
        {"Address Decoder Enable"              ADER_ENABLE}                 \
        {"MCST/CBLT Address Register"          MCST/CBLT_Address}        \
        {"MCST/CBLT Control Register"          MCST/CBLT_Ctrl}           \
        {"Event Counter Register"              EvCounter}                \
        {"Op Code Handshake Register"          OpCodeCtrl}               \
        {"Op Code Register"                    OpCode}                   \
    }
}

proc {CAEN V1290_DAQ-reset} {args} {
#   V1290
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Firmware] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

#    software reset the board
    write-vme-register $module.Reset 0
#    setup
    write-vme-register $module.Ctrl 0x0e
}

proc {CAEN V1290_DAQ-flush} {args} {
#   V1290
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
    write-vme-register $module.Clear 0
}

proc {CAEN V1290_DAQ-go} {args} {
#   V1290
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
    write-vme-register $module.Clear 0
    write-vme-register $module.Ctrl.Event_Mode 1
}

proc {CAEN V1290_DAQ-halt} {args} {
#   V1290
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V1290_DAQ-setup} {args} {
#   V1290
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    software reset the board
    write-vme-register $module.Clear 0

#    initialise 
    initialise-vme-registers $module.GEO_Address
}

#   for parameter save/restore
set {CAEN V1290_registersavepatterns} {}


